!*****************************************************************************
!                                                                            *
!  DISPLAY.F90                                                               *
!                                                                            *
!  This program resizes the desktop to 800x600 using the fg_modeset()        *
!  function.                                                                 *
!                                                                            *
!*****************************************************************************

integer*4 function WinMain (hInstance, hPrevInstance, lpszCmdParam, nCmdShow)
!MS$ATTRIBUTES STDCALL, ALIAS : '_WinMain@16' :: WinMain
use msfwina
use fgwin

interface
integer*4 function WindowProc (window, message, wParam, lParam)
!MS$ATTRIBUTES STDCALL, ALIAS:'_WindowProc@16' :: WindowProc
integer*4 window, message, wParam, lParam
end function WindowProc
end interface

integer*4 hInstance, hPrevInstance, lpszCmdParam, nCmdShow

include 'display.fi'

character*12      AppName
integer*4         iret
integer*4         window
type (T_MSG)      msg
type (T_WNDCLASS) wndclass

data AppName /'FGdisplay'C/

if (hPrevInstance == 0) then
   wndclass%style         = CS_HREDRAW .or. CS_VREDRAW .or. CS_OWNDC
   wndclass%lpfnWndProc   = LOC(WindowProc)
   wndclass%cbClsExtra    = 0
   wndclass%cbWndExtra    = 0
   wndclass%hInstance     = hInstance
   wndclass%hIcon         = LoadIcon(NULL,IDI_APPLICATION)
   wndclass%hCursor       = LoadCursor(NULL,IDC_ARROW)
   wndclass%hbrBackground = NULL
   wndclass%lpszMenuName  = NULL
   wndclass%lpszClassName = LOC(AppName)
   iret = RegisterClass(wndclass)
   lpszCmdParam = lpszCmdParam
end if

window = CreateWindowEx(    &
   WS_EX_TOPMOST,           &  ! extended window style
   AppName,                 &  ! window class name
   'Change Display Settings'C, &  ! window caption
   WS_POPUP,                &  ! window style
   0,                       &  ! initial x position
   0,                       &  ! initial y position
   WIDTH,                   &  ! initial x size
   HEIGHT,                  &  ! initial y size
   NULL,                    &  ! parent window handle
   NULL,                    &  ! window menu handle
   hInstance,               &  ! program instance handle
   NULL)                       ! creation parameters

iret = ShowWindow(window,nCmdShow)
iret = UpdateWindow(window)

do while (GetMessage(msg,NULL,0,0))
   iret = TranslateMessage(msg)
   iret = DispatchMessage(msg)
end do

WinMain = msg%wParam
return
end

!*****************************************************************************
!                                                                            *
!  WindowProc                                                                *
!                                                                            *
!  Window procedure to handle messages sent to the window.                   *
!                                                                            *
!*****************************************************************************

integer*4 function WindowProc (window, message, wParam, lParam)
!MS$ATTRIBUTES STDCALL, ALIAS:'_WindowProc@16' :: WindowProc
use msfwina
use fgwin
integer*4 window, message, wParam, lParam

include 'display.fi'

type (T_PAINTSTRUCT) ps
integer*4 hdc, hpal, hvb
integer*4 iret

save hdc, hpal, hvb

WindowProc = 0

select case (message)

   case (WM_CREATE)
      hdc = GetDC(window)
      call fg_setdc(hdc)
      hpal = fg_defpal()
      call fg_realize(hpal)
      iret = ShowWindow(window,SW_SHOWNORMAL)

      if (fg_modetest(WIDTH,HEIGHT,fg_colors()) /= 0) then
         iret = MessageBox(window,'Cannot set 800x600 desktop'C,'Error'C,MB_OK.or.MB_ICONSTOP)
         iret = DestroyWindow(window)
         return
      end if
      iret = fg_modeset(WIDTH,HEIGHT,fg_colors(),1)

      call fg_vbinit
      hvb = fg_vballoc(WIDTH,HEIGHT)
      iret = fg_vbopen(hvb)
      call fg_vbcolors

      call fg_setcolor(19)
      call fg_fillpage
      return

   case (WM_KEYDOWN)
      if (wParam == VK_ESCAPE .or. wParam == VK_F12) then
         iret = DestroyWindow(window)
      end if
      return

   case (WM_PAINT)
      iret = BeginPaint(window,ps)
      call fg_vbpaste(0,WIDTH-1,0,HEIGHT-1,0,HEIGHT-1)
      iret = EndPaint(window,ps)
      return

   case (WM_SETFOCUS)
      call fg_realize(hpal)
      iret = InvalidateRect(window,NULL_RECT,.TRUE.)
      return

   case (WM_DESTROY)
      call fg_vbclose
      call fg_vbfree(hvb)
      call fg_vbfin
      iret = DeleteObject(hpal)
      iret = ReleaseDC(window,hdc)
      iret = fg_modeset(0,0,0,0)
      call PostQuitMessage(0)
      return

end select

WindowProc = DefWindowProc(window,message,wParam,lParam)
return
end
