{*****************************************************************************
*                                                                            *
*  DISPLAY.DPR                                                               *
*  DISPLAYU.PAS                                                              *
*                                                                            *
*  This program resizes the desktop to 800x600 using the fg_modeset()        *
*  function. It requires Win32.                                              *
*                                                                            *
*****************************************************************************}

unit DisplayU;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, FGWin;

type
  TForm1 = class(TForm)
    procedure AppOnActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
const
  vbWidth = 800;
  vbHeight = 600;

var
  dc   : hDC;
  hpal : hPalette;
  hvb  : integer;

procedure TForm1.AppOnActivate(Sender: TObject);
begin
  fg_realize(hpal);
  Invalidate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  dc := GetDC(Form1.Handle);
  fg_setdc(dc);
  hpal := fg_defpal;
  fg_realize(hpal);
  Form1.Visible := True;

  if fg_modetest(vbWidth,vbHeight,fg_colors) <> 0 then
  begin
    MessageDlg('Cannot set 800x600 desktop',mtError,[mbOK],0);
    Application.Terminate;
    Exit;
  end;
  fg_modeset(vbWidth,vbHeight,fg_colors,1);
  Form1.WindowState := wsMaximized;

  fg_vbinit;
  hvb := fg_vballoc(vbWidth,vbHeight);
  fg_vbopen(hvb);
  fg_vbcolors;

  fg_setcolor(19);
  fg_fillpage;
  Application.OnActivate := AppOnActivate;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_Escape) or (Key = VK_F12) then Application.Terminate;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  fg_vbpaste(0,vbWidth-1,0,vbHeight-1,0,vbHeight-1);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  fg_vbclose;
  fg_vbfree(hvb);
  fg_vbfin;
  fg_modeset(0,0,0,0);
  DeleteObject(hpal);
  ReleaseDC(Form1.Handle,dc);
end;

end.
