/****************************************************************************\
*                                                                            *
*  PANNER.CPP                                                                *
*  PANNERU.CPP                                                               *
*                                                                            *
*  This program shows how to pan the contents of a virtual buffer through    *
*  a smaller window.                                                         *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "PannerU.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner),
    WIDTH(640),
    HEIGHT(480)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb = fg_vballoc(WIDTH,HEIGHT);
   fg_vbopen(hvb);
   fg_vbcolors();

   fg_showbmp("PORCH.BMP",0);
   x = y = 0;

   Application->OnActivate = OnActivate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbpaste(x,x+(WIDTH-1),y,y+(HEIGHT-1),0,HEIGHT-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   cxClient = ClientWidth;
   cyClient = ClientHeight;
   Invalidate();
   if (cxClient < WIDTH)
   {
      xlimit = WIDTH - cxClient;
      if (x > 0)      Left1->Enabled = True;
      if (x < xlimit) Right1->Enabled = True;
   }
   else
   {
      xlimit = 0;
      Left1->Enabled = False;
      Right1->Enabled = False;
   }
   if (cyClient < HEIGHT)
   {
      ylimit = HEIGHT - cyClient;
      if (y > 0)      Up1->Enabled = False;
      if (y < ylimit) Down1->Enabled = True;
   }
   else
   {
      ylimit = 0;
      Up1->Enabled = False;
      Down1->Enabled = False;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   fg_vbclose();
   fg_vbfree(hvb);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Left1Click(TObject *Sender)
{
   if (x == xlimit) Right1->Enabled = True;
   x--;
   fg_vbpaste(x,x+(WIDTH-1),y,y+(HEIGHT-1),0,HEIGHT-1);
   if (x == 0) Left1->Enabled = False;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Right1Click(TObject *Sender)
{
   if (x == 0) Left1->Enabled = True;
   x++;
   fg_vbpaste(x,x+(WIDTH-1),y,y+(HEIGHT-1),0,HEIGHT-1);
   if (x == xlimit) Right1->Enabled = False;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Up1Click(TObject *Sender)
{
    if (y == ylimit) Down1->Enabled = True;
    y--;
    fg_vbpaste(x,x+(WIDTH-1),y,y+(HEIGHT-1),0,HEIGHT-1);
    if (y == 0) Up1->Enabled = False;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Down1Click(TObject *Sender)
{
   if (y == 0) Up1->Enabled = True;
   y++;
   fg_vbpaste(x,x+(WIDTH-1),y,y+(HEIGHT-1),0,HEIGHT-1);
   if (y == ylimit) Down1->Enabled = False;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Reset1Click(TObject *Sender)
{
   x = y = 0;
   fg_vbpaste(0,WIDTH-1,0,HEIGHT-1,0,HEIGHT-1);
   if (xlimit > 0) Right1->Enabled = True;
   if (ylimit > 0) Down1->Enabled = True;
   Left1->Enabled = False;
   Up1->Enabled = False;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Quit1Click(TObject *Sender)
{
   Application->Terminate();
}
//---------------------------------------------------------------------------
