/****************************************************************************\
*                                                                            *
*  SCROLL.CPP                                                                *
*  SCROLLU.CPP                                                               *
*                                                                            *
*  This program demonstrates circular scrolling within a virtual buffer.     *
*                                                                            *
*  Because fg_scroll() requires a "hidden" virtual buffer to save and then   *
*  restore portions of the area being scrolled, we create a second virtual   *
*  buffer for this purpose.                                                  *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "ScrollU.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner),
    WIDTH(320),
    HEIGHT(200)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnIdle(TObject *Sender, bool &Done)
{
   scroll();
   Done = False;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb1 = fg_vballoc(WIDTH,HEIGHT);
   hvb2 = fg_vballoc(WIDTH,HEIGHT);
   fg_vbopen(hvb2);
   fg_vbcolors();
   fg_vbopen(hvb1);
   fg_vbcolors();
   fg_sethpage(hvb2);

   fg_setcolor(19);
   fg_fillpage();
   fg_setcolor(25);
   fg_rect(132,188,50,150);

   fg_setcolor(20);
   fg_move(160,67);
   fg_draw(175,107);
   fg_draw(140,82);
   fg_draw(180,82);
   fg_draw(145,107);
   fg_draw(160,67);
   fg_paint(160,77);
   fg_paint(150,87);
   fg_paint(160,87);
   fg_paint(170,87);
   fg_paint(155,97);
   fg_paint(165,97);

   Application->OnActivate = OnActivate;
   Application->OnIdle = OnIdle;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   cxClient = ClientWidth;
   cyClient = ClientHeight;
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   fg_vbclose();
   fg_vbfree(hvb1);
   fg_vbfree(hvb2);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}

/****************************************************************************\
*                                                                            *
*  The scroll() function moves the scrolling region up four pixels in a      *
*  circular manner. It is called from the OnIdle event handler.              *
*                                                                            *
\****************************************************************************/

void TForm1::scroll()
{
   fg_scroll(136,184,50,150,-4,0);
   fg_vbscale(0,WIDTH-1,0,HEIGHT-1,0,cxClient-1,0,cyClient-1);
}
